/***************************************************************************
                          dialog_appearance.h  -  description
                             -------------------
    begin                : Sun Mar 26 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _APPEARANCEDIALOG
#define _APPEARANCEDIALOG

/* include files for QT */
#include <qvariant.h>
#include <qbuttongroup.h>
#include <qframe.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qslider.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcolordialog.h>

/* application specific includes */
#include "kglmolecule.h"
#include "dialog_appearance_ui.h"

/* class CAppearanceDialog */
class CAppearanceDialog : public CAppearanceDialogUI
{
  Q_OBJECT

public:
  /* constructor */
  CAppearanceDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

  /* destructor */
  ~CAppearanceDialog();

public:
  /* get... */
  int getApplyStatus(void) {return(!applyButton->isEnabled());}
  QColor getBGColorPrint(void);
  CKGLMolecule* getMolecule(void);

  /* set... */
  void setBGColorPrint(QColor colorPrint);
  void setMolecule(CKGLMolecule *mol);

private slots:
  void applyClicked(void);
  void resetClicked(void);
  void initWidgets(void);
  void colorFlatButtonClicked(void);
  void colorOpenGLButtonClicked(void);
  void colorPrintButtonClicked(void);
  void perspectiveChanged(int perspective);
  void radiusReductionChanged(int radiusReduction);
  void labelChanged(int label);     
protected:
  /* protected members */
  CKGLMolecule *molecule;
  QColor bgColorPrint;
};

#endif /* _APPEARANCEDIALOG */
