/***************************************************************************
                          dialog_atoms.h  -  description
                             -------------------
    begin                : Sun Mar 12 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ATOMSDIALOG
#define _ATOMSDIALOG

/* include files for QT */
#include <qvariant.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtimer.h>
#include <qlineedit.h>
#include <qcolordialog.h>

/* application specific includes */
#include "kglmolecule.h"
#include "dialog_atoms_ui.h"

/* class CAtomsDialog */
class CAtomsDialog : public CAtomsDialogUI
{
  Q_OBJECT

public:
  /* constructor */
  CAtomsDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

  /* destructor */
  ~CAtomsDialog();

public:
  /* get... */
  int getApplyStatus(void) {return(!applyButton->isEnabled());}
  CKPeriodicSystem* getPeriodicSystem(void) {return(periodicsystem);}
  CKGLMolecule* getMolecule(void);

  /* set... */
  void setPeriodicSystem(CKPeriodicSystem *ps);
  void setMolecule(CKGLMolecule *mol);

private slots:
  void applyClicked(void);
  void resetClicked(void);
  void colorButtonClicked(void);
  void fillAtomsListBox(void);
  void rotateStructure(void);
  void atomsListboxChanged(int newIndex);
  void radiusLineEditChanged(const QString& newRadius);
  void tabChanged(QWidget*);
  void slicesChanged(int newSlices);
  void stacksChanged(int newStacks);
  void initWidgets(void);

protected:
  /* events */
  void paintEvent(QPaintEvent*);

  /* protected members */
  CGLAtom* glAtom;
  CGLAtom* glAtomStructure;
  CKPeriodicSystem *periodicsystem;
  CKGLMolecule *molecule;
  QTimer *timer;
  float rotX;
  float rotY;
  float rotZ;
};

#endif /* _ATOMSDIALOG */
