/***************************************************************************
                          dialog_bonds.h  -  description
                             -------------------
    begin                : Tue Mar 14 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _BONDSDIALOG
#define _BONDSDIALOG

/* include files for QT */
#include <qvariant.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtimer.h>
#include <qcolordialog.h>

/* application specific includes */
#include "kglmolecule.h"
#include "dialog_bonds_ui.h"

/* class CBondsDialog */
class CBondsDialog : public CBondsDialogUI
{
  Q_OBJECT

public:
  /* constructor */
  CBondsDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

  /* destructor */
  ~CBondsDialog();

public:
  /* get... */
  int getApplyStatus(void) {return(!applyButton->isEnabled());}
  CKGLMolecule* getMolecule(void);

  /* set... */
  void setMolecule(CKGLMolecule *mol);

private slots:
  void applyClicked(void);
  void resetClicked(void);
  void colorButtonClicked(void);
  void rotateStructure(void);
  void radiusLineEditChanged(const QString& newRadius);
  void bondFudgeLineEditChanged(const QString& newBondFudge);  
  void slicesChanged(int newSlices);
  void tabChanged(QWidget*);
  void initWidgets(void);
  
protected:
  /* events */
  void paintEvent(QPaintEvent*);

  /* protected members */
  CGLBond* glBond;
  CGLBond* glBondStructure;
  CKGLMolecule *molecule;
  QTimer *timer;
  float rotX;
  float rotY;
  float rotZ;
};

#endif /* _BONDSDIALOG */
