/***************************************************************************
                          dialog_vrml.h  -  description
                             -------------------
    begin                : Fri Jul 14 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _VRMLDIALOG
#define _VRMLDIALOG

/* include files for QT */
#include <qvariant.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qslider.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcolordialog.h>

/* application specific includes */
#include "vrmlfile.h"
#include "dialog_vrml_ui.h"

/* class CVRMLDialog */
class CVRMLDialog : public CVRMLDialogUI
{
  Q_OBJECT

public:
  /* constructor */
  CVRMLDialog(QWidget *parent = 0, const char *name = 0, WFlags f = 0);

  /* destructor */
  ~CVRMLDialog();

public:
  /* set ... */
  void setAlternateAtomRadius(int newAlternateAtomRadius);
  void setAlternateAtomColor(int newAlternateAtomColor);
  void setAtomColor(QColor newAtomColor);
  void setAtomRadius(float newAtomRadius);
  void setBondRadius(float newBondRadius);
  void setAlternateBondColor(int newAlternateBondColor);
  void setBondColor(QColor newBondColor);
  void setEnableTextureMapping(int newEnableTextureMapping);
  void setImageTextureURL(QString newImageTextureURL);
  void setEnableDiffuseColor(int newEnableDiffuseColor);
  void setEnableEmissiveColor(int newEnableEmissiveColor);
  void setEnableSpecularColor(int newEnableSpecularColor);
  void setDiffuseColorFactor(float newDiffuseColorFactor);
  void setEmissiveColorFactor(float newEmissiveColorFactor);
  void setSpecularColorFactor(float newSpecularColorFactor);
  void setShininess(float newShininess);

  /* get ... */
  int getApplyStatus(void) {return(!applyButton->isEnabled());}
  int getAlternateAtomRadius(void);
  int getAlternateAtomColor(void);
  QColor getAtomColor(void);
  float getAtomRadius(void);
  float getBondRadius(void);
  int getAlternateBondColor(void);
  QColor getBondColor(void);
  int getEnableTextureMapping(void);
  QString getImageTextureURL(void);
  int getEnableDiffuseColor(void);
  int getEnableEmissiveColor(void);
  int getEnableSpecularColor(void);
  float getDiffuseColorFactor(void);
  float getEmissiveColorFactor(void);
  float getSpecularColorFactor(void);
  float getShininess(void);

private slots:
  void applyClicked(void);
  void resetClicked(void);
  void tab1AtomColorButtonClicked(void);
  void tab1AtomColorButtonGroupClicked(int id);
  void tab1AtomRadiusButtonGroupClicked(int id);
  void tab2BondColorButtonClicked(void);
  void tab2BondColorButtonGroupClicked(int id);
  void tab3TextureButtonGroupClicked(int id);
  void tab3DiffuseColorCheckBoxChanged(int state);
  void tab3EmissiveColorCheckBoxChanged(int state);
  void tab3SpecularColorCheckBoxChanged(int state);
  void lineEditChanged(const QString&);
  void sliderChanged(int);

protected:
  /* protected members */

};

#endif /* _VRMLDIALOG */
