/***************************************************************************
                          molecule.cpp  -  description
                             -------------------
    begin                : Sat Jan 22 2000
    copyright            : (C) 2000 - 2003 by M. Hoverath
    email                : mario.hoverath@uni-koeln.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "molecule.h"

///////////////////////////////////////////////////////////////////////////// 
// definition of the class CPeriodicSystem
///////////////////////////////////////////////////////////////////////////// 

///////////////////////////////////////////////////////////////////////////// 
// constructor
CPeriodicSystem::CPeriodicSystem(QObject *parent, const char *name)
  : QObject(parent, name)
{
  // set symbols, radii, color, pattern to default
  RestoreData();						
}

/////////////////////////////////////////////////////////////////////////////
// destructor
CPeriodicSystem::~CPeriodicSystem()
{

}

/////////////////////////////////////////////////////////////////////////////
// = operator
CPeriodicSystem& CPeriodicSystem::operator=(CPeriodicSystem &pse)
{
  for(int i = 0; i < 109; i++)
  {
    Radius[i] = pse.Radius[i];
    Color[i] = pse.Color[i];
    Pattern[i] = pse.Pattern[i];
  }
  return *this;
}

/////////////////////////////////////////////////////////////////////////////
// RestoreData
void CPeriodicSystem::RestoreData(void)
{
  // set elementsymbols
  Symbol[0] = "H";
  Symbol[1] = "He";
  Symbol[2] = "Li";
  Symbol[3] = "Be";
  Symbol[4] = "B";
  Symbol[5] = "C";
  Symbol[6] = "N";
  Symbol[7] = "O";
  Symbol[8] = "F";
  Symbol[9] = "Ne";
  Symbol[10] = "Na";
  Symbol[11] = "Mg";
  Symbol[12] = "Al";
  Symbol[13] = "Si";
  Symbol[14] = "P";
  Symbol[15] = "S";
  Symbol[16] = "Cl";
  Symbol[17] = "Ar";
  Symbol[18] = "K";
  Symbol[19] = "Ca";
  Symbol[20] = "Sc";
  Symbol[21] = "Ti";
  Symbol[22] = "V";
  Symbol[23] = "Cr";
  Symbol[24] = "Mn";
  Symbol[25] = "Fe";
  Symbol[26] = "Co";
  Symbol[27] = "Ni";
  Symbol[28] = "Cu";
  Symbol[29] = "Zn";
  Symbol[30] = "Ga";
  Symbol[31] = "Ge";
  Symbol[32] = "As";
  Symbol[33] = "Se";
  Symbol[34] = "Br";
  Symbol[35] = "Kr";
  Symbol[36] = "Rb";
  Symbol[37] = "Sr";
  Symbol[38] = "Y";
  Symbol[39] = "Zr";
  Symbol[40] = "Nb";
  Symbol[41] = "Mo";
  Symbol[42] = "Tc";
  Symbol[43] = "Ru";
  Symbol[44] = "Rh";
  Symbol[45] = "Pd";
  Symbol[46] = "Ag";
  Symbol[47] = "Cd";
  Symbol[48] = "In";
  Symbol[49] = "Sn";
  Symbol[50] = "Sb";
  Symbol[51] = "Te";
  Symbol[52] = "I";
  Symbol[53] = "Xe";
  Symbol[54] = "Cs";
  Symbol[55] = "Ba";
  Symbol[56] = "La";
  Symbol[57] = "Ce";
  Symbol[58] = "Pr";
  Symbol[59] = "Nd";
  Symbol[60] = "Pm";
  Symbol[61] = "Sm";
  Symbol[62] = "Eu";
  Symbol[63] = "Gd";
  Symbol[64] = "Tb";
  Symbol[65] = "Dy";
  Symbol[66] = "Ho";
  Symbol[67] = "Er";
  Symbol[68] = "Tm";
  Symbol[69] = "Yb";
  Symbol[70] = "Lu";
  Symbol[71] = "Hf";
  Symbol[72] = "Ta";
  Symbol[73] = "W";
  Symbol[74] = "Re";
  Symbol[75] = "Os";
  Symbol[76] = "Ir";
  Symbol[77] = "Pt";
  Symbol[78] = "Au";
  Symbol[79] = "Hg";
  Symbol[80] = "Tl";
  Symbol[81] = "Pb";
  Symbol[82] = "Bi";
  Symbol[83] = "Po";
  Symbol[84] = "At";
  Symbol[85] = "Rn";
  Symbol[86] = "Fr";
  Symbol[87] = "Ra";
  Symbol[88] = "Ac";
  Symbol[89] = "Th";
  Symbol[90] = "Pa";
  Symbol[91] = "U";
  Symbol[92] = "Np";
  Symbol[93] = "Pu";
  Symbol[94] = "Am";
  Symbol[95] = "Cm";
  Symbol[96] = "Bk";
  Symbol[97] = "Cf";
  Symbol[98] = "Es";
  Symbol[99] = "Fm";
  Symbol[100] = "Md";
  Symbol[101] = "No";
  Symbol[102] = "Lr";
  Symbol[103] = "Rf";
  Symbol[104] = "Ha";
  Symbol[105] = "Unh";
  Symbol[106] = "Uns";
  Symbol[107] = "Uno";
  Symbol[108] = "Une";

  // Radii
  Radius[0] = (float)0.320;
  Radius[1] = (float)0.930;
  Radius[2] = (float)1.230;
  Radius[3] = (float)0.900;
  Radius[4] = (float)0.820;
  Radius[5] = (float)0.770;
  Radius[6] = (float)0.750;
  Radius[7] = (float)0.730;
  Radius[8] = (float)0.720;
  Radius[9] = (float)0.710;
  Radius[10] = (float)1.540;
  Radius[11] = (float)1.360;
  Radius[12] = (float)1.180;
  Radius[13] = (float)1.110;
  Radius[14] = (float)1.060;
  Radius[15] = (float)1.020;
  Radius[16] = (float)0.990;
  Radius[17] = (float)0.980;
  Radius[18] = (float)2.030;
  Radius[19] = (float)1.740;
  Radius[20] = (float)1.440;
  Radius[21] = (float)1.320;
  Radius[22] = (float)1.220;
  Radius[23] = (float)1.180;
  Radius[24] = (float)1.170;
  Radius[25] = (float)1.170;
  Radius[26] = (float)1.160;
  Radius[27] = (float)1.150;
  Radius[28] = (float)1.170;
  Radius[29] = (float)1.250;
  Radius[30] = (float)1.260;
  Radius[31] = (float)1.220;
  Radius[32] = (float)1.200;
  Radius[33] = (float)1.160;
  Radius[34] = (float)1.140;
  Radius[35] = (float)1.120;
  Radius[36] = (float)2.160;
  Radius[37] = (float)1.910;
  Radius[38] = (float)1.620;
  Radius[39] = (float)1.450;
  Radius[40] = (float)1.340;
  Radius[41] = (float)1.300;
  Radius[42] = (float)1.270;
  Radius[43] = (float)1.250;
  Radius[44] = (float)1.250;
  Radius[45] = (float)1.280;
  Radius[46] = (float)1.340;
  Radius[47] = (float)1.480;
  Radius[48] = (float)1.440;
  Radius[49] = (float)1.410;
  Radius[50] = (float)1.400;
  Radius[51] = (float)1.360;
  Radius[52] = (float)1.330;
  Radius[53] = (float)1.310;
  Radius[54] = (float)2.350;
  Radius[55] = (float)1.980;
  Radius[56] = (float)1.690;
  Radius[57] = (float)1.650;
  Radius[58] = (float)1.650;
  Radius[59] = (float)1.640;
  Radius[60] = (float)1.630;
  Radius[61] = (float)1.620;
  Radius[62] = (float)1.850;
  Radius[63] = (float)1.610;
  Radius[64] = (float)1.590;
  Radius[65] = (float)1.590;
  Radius[66] = (float)1.580;
  Radius[67] = (float)1.570;
  Radius[68] = (float)1.560;
  Radius[69] = (float)1.740;
  Radius[70] = (float)1.560;
  Radius[71] = (float)1.440;
  Radius[72] = (float)1.340;
  Radius[73] = (float)1.300;
  Radius[74] = (float)1.280;
  Radius[75] = (float)1.260;
  Radius[76] = (float)1.270;
  Radius[77] = (float)1.300;
  Radius[78] = (float)1.340;
  Radius[79] = (float)1.490;
  Radius[80] = (float)1.480;
  Radius[81] = (float)1.470;
  Radius[82] = (float)1.460;
  Radius[83] = (float)1.460;
  Radius[84] = (float)1.450;
  Radius[85] = (float)1.440;
  Radius[86] = (float)2.510;
  Radius[87] = (float)2.140;
  Radius[88] = (float)1.750;
  Radius[89] = (float)1.650;
  Radius[90] = (float)1.530;
  Radius[91] = (float)1.420;
  Radius[92] = (float)1.410;
  Radius[93] = (float)1.410;
  Radius[94] = (float)1.610;
  Radius[95] = (float)1.400;
  Radius[96] = (float)1.400;
  Radius[97] = (float)1.390;
  Radius[98] = (float)1.390;
  Radius[99] = (float)1.390;
  Radius[100] = (float)1.380;
  Radius[101] = (float)1.380;
  Radius[102] = (float)1.380;
  Radius[103] = (float)1.380;
  Radius[104] = (float)1.380;
  Radius[105] = (float)1.380;
  Radius[106] = (float)1.380;
  Radius[107] = (float)1.380;
  Radius[108] = (float)1.380;

  // Colors
  Color[0].setRgb(220,220,220);
  Color[1].setRgb(160,160,160);
  Color[2].setRgb(160,160,160);
  Color[3].setRgb(160,160,160);
  Color[4].setRgb(160,160,160);
  Color[5].setRgb(50,50,50);
  Color[6].setRgb(0,200,0);
  Color[7].setRgb(0,0,200);
  Color[8].setRgb(160,160,0);
  Color[9].setRgb(160,160,160);
  Color[10].setRgb(160,160,160);
  Color[11].setRgb(160,160,160);
  Color[12].setRgb(160,160,160);
  Color[13].setRgb(160,160,160);
  Color[14].setRgb(200,0,0);
  Color[15].setRgb(220,220,0);
  Color[16].setRgb(0,170,0);
  Color[17].setRgb(160,160,160);
  Color[18].setRgb(160,160,160);
  Color[19].setRgb(160,160,160);
  Color[20].setRgb(160,160,160);
  Color[21].setRgb(160,160,160);
  Color[22].setRgb(160,160,160);
  Color[23].setRgb(160,160,160);
  Color[24].setRgb(160,160,160);
  Color[25].setRgb(160,160,160);
  Color[26].setRgb(160,160,160);
  Color[27].setRgb(160,160,160);
  Color[28].setRgb(160,160,160);
  Color[29].setRgb(160,160,160);
  Color[30].setRgb(160,160,160);
  Color[31].setRgb(160,160,160);
  Color[32].setRgb(160,160,160);
  Color[33].setRgb(170,0,0);
  Color[34].setRgb(100,100,0);
  Color[35].setRgb(160,160,160);
  Color[36].setRgb(160,160,160);
  Color[37].setRgb(160,160,160);
  Color[38].setRgb(160,160,160);
  Color[39].setRgb(160,160,160);
  Color[40].setRgb(160,160,160);
  Color[41].setRgb(160,160,160);
  Color[42].setRgb(160,160,160);
  Color[43].setRgb(160,160,160);
  Color[44].setRgb(160,160,160);
  Color[45].setRgb(160,160,160);
  Color[46].setRgb(160,160,160);
  Color[47].setRgb(160,160,160);
  Color[48].setRgb(160,160,160);
  Color[49].setRgb(160,160,160);
  Color[50].setRgb(160,160,160);
  Color[51].setRgb(160,160,160);
  Color[52].setRgb(90,90,100);
  Color[53].setRgb(160,160,160);
  Color[54].setRgb(160,160,160);
  Color[55].setRgb(160,160,160);
  Color[56].setRgb(160,160,160);
  Color[57].setRgb(160,160,160);
  Color[58].setRgb(160,160,160);
  Color[59].setRgb(160,160,160);
  Color[60].setRgb(160,160,160);
  Color[61].setRgb(160,160,160);
  Color[62].setRgb(160,160,160);
  Color[63].setRgb(160,160,160);
  Color[64].setRgb(160,160,160);
  Color[65].setRgb(160,160,160);
  Color[66].setRgb(160,160,160);
  Color[67].setRgb(160,160,160);
  Color[68].setRgb(160,160,160);
  Color[69].setRgb(160,160,160);
  Color[70].setRgb(160,160,160);
  Color[71].setRgb(160,160,160);
  Color[72].setRgb(160,160,160);
  Color[73].setRgb(160,160,160);
  Color[74].setRgb(160,160,160);
  Color[75].setRgb(160,160,160);
  Color[76].setRgb(160,160,160);
  Color[77].setRgb(160,160,160);
  Color[78].setRgb(160,160,160);
  Color[79].setRgb(160,160,160);
  Color[80].setRgb(160,160,160);
  Color[81].setRgb(160,160,160);
  Color[82].setRgb(160,160,160);
  Color[83].setRgb(160,160,160);
  Color[84].setRgb(160,160,160);
  Color[85].setRgb(160,160,160);
  Color[86].setRgb(160,160,160);
  Color[87].setRgb(160,160,160);
  Color[88].setRgb(160,160,160);
  Color[89].setRgb(160,160,160);
  Color[90].setRgb(160,160,160);
  Color[91].setRgb(160,160,160);
  Color[92].setRgb(160,160,160);
  Color[93].setRgb(160,160,160);
  Color[94].setRgb(160,160,160);
  Color[95].setRgb(160,160,160);
  Color[96].setRgb(160,160,160);
  Color[97].setRgb(160,160,160);
  Color[98].setRgb(160,160,160);
  Color[99].setRgb(160,160,160);
  Color[100].setRgb(160,160,160);
  Color[101].setRgb(160,160,160);
  Color[102].setRgb(160,160,160);
  Color[103].setRgb(160,160,160);
  Color[104].setRgb(160,160,160);
  Color[105].setRgb(160,160,160);
  Color[106].setRgb(160,160,160);
  Color[107].setRgb(160,160,160);
  Color[108].setRgb(160,160,160);

  // Patterns
  for(int i = 0; i < 109; i++)
  {
    Pattern[i] = Qt::SolidPattern;
  }
}

/////////////////////////////////////////////////////////////////////////////
// SetRadius
int CPeriodicSystem::SetRadius(int ordinalNumber, float radius)
{
  if((ordinalNumber < 1) || (ordinalNumber > 109) || (Radius < 0)) return(FALSE);
  Radius[ordinalNumber - 1] = radius;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetColor
int CPeriodicSystem::SetColor(int ordinalNumber, QColor color)
{
  if((ordinalNumber < 1) || (ordinalNumber > 109)) return(FALSE);
  Color[ordinalNumber - 1] = color;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetPattern
int CPeriodicSystem::SetPattern(int ordinalNumber, int pattern)
{
  if((ordinalNumber < 1) || (ordinalNumber > 109)) return(FALSE);
  Pattern[ordinalNumber - 1] = pattern;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// GetSymbol
QString CPeriodicSystem::GetSymbol(int ordinalNumber)
{
  if((ordinalNumber >= 0) && (ordinalNumber <= 109))
    return Symbol[ordinalNumber - 1];
  else
    return "";
}

/////////////////////////////////////////////////////////////////////////////
// GetOrdinalNumber
int CPeriodicSystem::GetOrdinalNumber(QString Symbol)
{
  Symbol.stripWhiteSpace();

  for(int i = 1; i <= 109; i++)
    if(Symbol == GetSymbol(i)) return i;

  return -1;
}

/////////////////////////////////////////////////////////////////////////////
// GetRadius
float CPeriodicSystem::GetRadius(int ordinalNumber)
{
  if((ordinalNumber >= 0) && (ordinalNumber <= 109))
    return Radius[ordinalNumber - 1];
  else
    return ((float) -1);
}

/////////////////////////////////////////////////////////////////////////////
// GetColor
QColor CPeriodicSystem::GetColor(int ordinalNumber)
{
  if((ordinalNumber >= 0) && (ordinalNumber <= 109))
    return Color[ordinalNumber - 1];
  else
  {
    tmpColor.setRgb(0, 0, 0);
    return (tmpColor);
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetPattern
int CPeriodicSystem::GetPattern(int ordinalNumber)
{
  if((ordinalNumber >= 0) && (ordinalNumber <= 109))
    return Pattern[ordinalNumber - 1];
  else
    return (Qt::SolidPattern);
}

/////////////////////////////////////////////////////////////////////////////
// definition of the class CCoordinateSystem
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// constructor
CCoordinateSystem::CCoordinateSystem(QObject *parent, const char *name)
  : QObject(parent, name)
{
  Reset();
}

/////////////////////////////////////////////////////////////////////////////
// destructor
CCoordinateSystem::  ~CCoordinateSystem()
{
}

/////////////////////////////////////////////////////////////////////////////
// = operator
CCoordinateSystem& CCoordinateSystem::operator=(CCoordinateSystem &cs)
{
  I.x = cs.I.x;
  I.y = cs.I.y;
  I.z = cs.I.z;
  J.x = cs.J.x;
  J.y = cs.J.y;
  J.z = cs.J.z;
  K.x = cs.K.x;
  K.y = cs.K.y;
  K.z = cs.K.z;
  return *this;
}

/////////////////////////////////////////////////////////////////////////////
// Rotate
int CCoordinateSystem::Rotate(int axis, float angle)
{
  // angle should be between -2 * Pi and 2 * Pi
  angle = fmod(angle, 2 * PI);
  // rotate I and J (K will be calculated: K = I x J)
  switch(axis)
  {
    case X_AXIS:
    {
      // x-axis
      tmp_point3d.y = I.y * (float)cos(angle)
                    - I.z * (float)sin(angle);
      tmp_point3d.z = I.y * (float)sin(angle)
                      + I.z * (float)cos(angle);
      I.y = tmp_point3d.y;
      I.z = tmp_point3d.z;
      tmp_point3d.y = J.y * (float)cos(angle)
                    - J.z * (float)sin(angle);
      tmp_point3d.z = J.y * (float)sin(angle)
                      + J.z * (float)cos(angle);
      J.y = tmp_point3d.y;
      J.z = tmp_point3d.z;
      break;
    }
    case Y_AXIS:
    {
      // y-axis
      tmp_point3d.x = I.x * (float)cos(angle)
                    + I.z * (float)sin(angle);
      tmp_point3d.z = - I.x * (float)sin(angle)
                      + I.z * (float)cos(angle);
      I.x = tmp_point3d.x;
      I.z = tmp_point3d.z;
      tmp_point3d.x = J.x * (float)cos(angle)
                    + J.z * (float)sin(angle);
      tmp_point3d.z = - J.x * (float)sin(angle)
                      + J.z * (float)cos(angle);
      J.x = tmp_point3d.x;
      J.z = tmp_point3d.z;
      break;
    }
    case Z_AXIS:
    {
      // z-axis
      tmp_point3d.x = I.x * (float)cos(angle)
                     + I.y * (float)sin(angle);
      tmp_point3d.y = - I.x * (float)sin(angle)
                     + I.y * (float)cos(angle);
      I.x = tmp_point3d.x;
      I.y = tmp_point3d.y;
      tmp_point3d.x = J.x * (float)cos(angle)
                     + J.y * (float)sin(angle);
      tmp_point3d.y = - J.x * (float)sin(angle)
                     + J.y * (float)cos(angle);
      J.x = tmp_point3d.x;
      J.y = tmp_point3d.y;
      break;
    }
    default: return(FALSE); break;
  }
  // correct rounding errors
  return(CorrectRoundingErrors());
}

/////////////////////////////////////////////////////////////////////////////
// CorrectRoundingErrors
int CCoordinateSystem::CorrectRoundingErrors(void)
{
  float factor = 1.0;
  float tmpSqrt = 1.0;
  // 1. set |I| = 1;
  if((tmpSqrt = sqrt(I.x * I.x + I.y * I.y + I.z * I.z)) == 0) return(FALSE);
  factor = 1.0 / tmpSqrt;
  I.x = I.x * factor;
  I.y = I.y * factor;
  I.z = I.z * factor;
  // 2. set angle(I,J) = Pi/2;
  if(((I.z * I.z) > (I.x * I.x)) && ((I.z * I.z) > (I.y * I.y)))
  {
    // I.z is the largest absolute value
    J.z = - I.x * J.x / I.z - I.y * J.y / I.z;
  }
  else
  {
    if(((I.y * I.y) > (I.x * I.x)) && ((I.y * I.y) > (I.z * I.z)))
    {
      // I.y is the largest absolute value
      J.y = - I.x * J.x / I.y - I.z * J.z / I.y;
    }
    else
    {
      if(((I.x * I.x) > (I.y * I.y)) && ((I.x * I.x) > (I.z * I.z)))
      {
        // I.x is the largest absolute value
        J.x = - I.y * J.y / I.x - I.z * J.z / I.x;
      }
      else
      {
        return(FALSE);
      }
    }
  }
  // 3. set |J| = 1;
  if((tmpSqrt = sqrt(J.x * J.x + J.y * J.y + J.z * J.z)) == 0) return(FALSE);
  factor = 1.0 / tmpSqrt;
  J.x = J.x * factor;
  J.y = J.y * factor;
  J.z = J.z * factor;
  // calculate K = I x J;
  K.x = I.y * J.z - I.z * J.y;
  K.y = I.z * J.x - I.x * J.z;
  K.z = I.x * J.y - I.y * J.x;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// Reset
void CCoordinateSystem::Reset(void)
{
  I.x = 1.0;
  I.y = 0.0;
  I.z = 0.0;
  J.x = 0.0;
  J.y = 1.0;
  J.z = 0.0;
  K.x = 0.0;
  K.y = 0.0;
  K.z = 1.0;
  tmp_point3d.x = 0.0;
  tmp_point3d.y = 0.0;
  tmp_point3d.z = 0.0;
}

/////////////////////////////////////////////////////////////////////////////
// GetVector
POINT3D CCoordinateSystem::GetVector(int axis)
{
  switch(axis)
  {
    case X_AXIS:  return(I); break;
    case Y_AXIS:  return(J); break;
    case Z_AXIS:  return(K); break;
    default:
    {
      tmp_point3d.x = 0.0;
      tmp_point3d.y = 0.0;
      tmp_point3d.z = 0.0;
      return(tmp_point3d);
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetVector
POINT3D CCoordinateSystem::GetInverseVector(int axis)
{
  // default return value
  tmp_point3d.x = 0.0;
  tmp_point3d.y = 0.0;
  tmp_point3d.z = 0.0;

  // temporary variables
  float tmp = 0.0;

  // create equations for calculating inverse matrix via gauss algorithm
  // equations to solve:
  // a.x * x + b.x * y + c.x * z = d.x
  // a.y * x + b.y * y + c.y * z = d.y
  // a.z * x + b.z * y + c.z * z = d.z
  POINT3D a = I;
  POINT3D b = J;
  POINT3D c = K;
  POINT3D d;
  // aa.x * y + bb.x * z = cc.x
  // aa.y * y + bb.y * z = cc.y
  POINT2D aa;
  POINT2D bb;
  POINT2D cc;
  // aaa * z = bbb
  float aaa = 0.0;
  float bbb = 0.0;

  switch(axis)
  {
    case X_AXIS: d.x = 1.0; d.y = 0.0; d.z = 0.0; break;
    case Y_AXIS: d.x = 0.0; d.y = 1.0; d.z = 0.0; break;
    case Z_AXIS: d.x = 0.0; d.y = 0.0; d.z = 1.0; break;
    default: return(tmp_point3d);
  }

  // change equations if nessesary
  if(a.x == 0.0)
  {
    if(a.y != 0.0)
    {
      // exchange equation 1 and 2
      tmp = a.x;
      a.x = a.y;
      a.y = tmp;
      tmp = b.x;
      b.x = b.y;
      b.y = tmp;
      tmp = c.x;
      c.x = c.y;
      c.y = tmp;
      tmp = d.x;
      d.x = d.y;
      d.y = tmp;
    }
    else
    {
      if(a.z != 0.0)
      {
        // exchange equation 1 and 3
        tmp = a.x;
        a.x = a.z;
        a.z = tmp;
        tmp = b.x;
        b.x = b.z;
        b.z = tmp;
        tmp = c.x;
        c.x = c.z;
        c.z = tmp;
        tmp = d.x;
        d.x = d.z;
        d.z = tmp;
      }
      else
      {
        // ivalid matrix
        return(tmp_point3d);
      }
    }
  }

  // eliminate x
  aa.x = (b.x * a.y / a.x) - b.y;
  bb.x = (c.x * a.y / a.x) - c.y;
  cc.x = (d.x * a.y / a.x) - d.y;
  aa.y = (b.x * a.z / a.x) - b.z;
  bb.y = (c.x * a.z / a.x) - c.z;
  cc.y = (d.x * a.z / a.x) - d.z;

  // change equations if nessesary
  if(aa.x == 0.0)
  {
    if(aa.y != 0.0)
    {
      // exchange equation 1 and 2
      tmp = aa.x;
      aa.x = aa.y;
      aa.y = tmp;
      tmp = bb.x;
      bb.x = bb.y;
      bb.y = tmp;
      tmp = cc.x;
      cc.x = cc.y;
      cc.y = tmp;
    }
    else
    {
      // ivalid matrix
      return(tmp_point3d);
    }
  }

  // eliminate y
  aaa = (aa.y * bb.x / aa.x) - bb.y;
  bbb = (cc.x * aa.y / aa.x) - cc.y;

  if(aaa == 0.0)
  {
    // ivalid matrix
    return(tmp_point3d);
  }

  // calculate vector
  tmp_point3d.z = bbb / aaa;
  tmp_point3d.y = (cc.x - bb.x * tmp_point3d.z) / aa.x;
  tmp_point3d.x = (d.x - c.x * tmp_point3d.z - b.x * tmp_point3d.y) / a.x;
  return (tmp_point3d);
}

/////////////////////////////////////////////////////////////////////////////
// GetMatrix
float CCoordinateSystem::GetMatrix(int axis, int component)
{
  switch(component)
  {
    case X_COMPONENT:
    {
      return((GetVector(axis)).x);
      break;
    }
    case Y_COMPONENT:
    {
      return((GetVector(axis)).y);
      break;
    }
    case Z_COMPONENT:
    {
      return((GetVector(axis)).z);
      break;
    }
    default:
    {
      return(0.0);
      break;
    }
  }
}

/////////////////////////////////////////////////////////////////////////////
// SetMatrix
int CCoordinateSystem::SetMatrix(float ix, float iy, float iz,
                                 float jx, float jy, float jz,
                                 float kx, float ky, float kz,
                                 int correctErrors)
{
  if((ix * ix > 1.0) ||(iy * iy > 1.0) || (iz * iz > 1.0) ||
     (jx * jx > 1.0) ||(jy * jy > 1.0) || (jz * jz > 1.0) ||
     (kx * kx > 1.0) ||(ky * ky > 1.0) || (kz * kz > 1.0)) return(FALSE);
  I.x = ix;
  I.y = iy;
  I.z = iz;
  J.x = jx;
  J.y = jy;
  J.z = jz;
  K.x = kx;
  K.y = ky;
  K.z = kz;
  return(correctErrors ? CorrectRoundingErrors() : TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// definition of the class CMolecule
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// constructor
CMolecule::CMolecule(QObject *parent, const char *name)
  : QObject(parent, name)
{
  Element = 0;
  BondPartners = 0;
  InitMolecule();
}

/////////////////////////////////////////////////////////////////////////////
// destructor
CMolecule::~CMolecule()
{
  if(Element != NULL) free(Element);
  if(BondPartners != NULL) free(BondPartners);
}

/////////////////////////////////////////////////////////////////////////////
// = operator
CMolecule& CMolecule::operator=(CMolecule &Mol)
{
  InitMolecule();
  ResetCoordinateSystem();

  // equalize members
  BondFudge = Mol.BondFudge;
  Title = Mol.Title;
  BondColor = Mol.BondColor;
  cs = Mol.cs;
  usedClientRect = Mol.usedClientRect;
  PerspectiveFactor = Mol.PerspectiveFactor;
  MaxAtomCenterDistance = Mol.MaxAtomCenterDistance;
  ZoomFactor = Mol.ZoomFactor;
  translation.x = Mol.translation.x;
  translation.y = Mol.translation.y;
  translation.z = Mol.translation.z;
  RadiusFactor = Mol.RadiusFactor;
  LabelType = Mol.LabelType;
  View = Mol.View;
  bgColor = Mol.bgColor;

  // equalize atoms and bonds
  ELEMENT TmpElement;
  POINT3D TmpPoint3D;
  int i = 0;
  for(i = 0; i < Mol.GetNumberOfAtoms(); i++)
  {
    TmpPoint3D = Mol.GetAtomCoordinate(i);
    TmpElement.x = TmpPoint3D.x;
    TmpElement.y = TmpPoint3D.y;
    TmpElement.z = TmpPoint3D.z;
    TmpElement.OrdinalNumber = Mol.GetOrdinalNumber(i);
    TmpElement.Label = Mol.GetLabel(i);
    TmpElement.Radius = Mol.GetRadius(i);
    TmpElement.Color = Mol.GetColor(i);
    TmpElement.Pattern = Mol.GetPattern(i);
    AddAtom(TmpElement);
  }

  for(i = NumberOfBonds - 1; i >= 0; i--)
  {
    DeleteBond(BondPartners[i].x, BondPartners[i].y);
  }

  for(i = 0; i < Mol.NumberOfBonds; i++)
  {
    AddBond(Mol.BondPartners[i].x, Mol.BondPartners[i].y);
  }
  return *this;
}

/////////////////////////////////////////////////////////////////////////////
// Serialize
void CMolecule::Serialize()
{
  // not yet implemented
}

/////////////////////////////////////////////////////////////////////////////
// Rotate
int CMolecule::Rotate(int axis, float angle)
{
  return(cs.Rotate(axis, angle));
}

/////////////////////////////////////////////////////////////////////////////
// ResetCoordinateSystem
void CMolecule::ResetCoordinateSystem(void)
{
  cs.Reset();
}

/////////////////////////////////////////////////////////////////////////////
// ResetTranslation
void CMolecule::ResetTranslation(void)
{
  translation.x = 0.0;
  translation.y = 0.0;
  translation.z = 0.0;
}

/////////////////////////////////////////////////////////////////////////////
// Translate I
void CMolecule::Translate(float transX, float transY, float transZ)
{
  translation.x = transX;
  translation.y = transY;
  translation.z = transZ;
}

/////////////////////////////////////////////////////////////////////////////
// Translate II
void CMolecule::Translate(POINT3D trans)
{
  translation.x = trans.x;
  translation.y = trans.y;
  translation.z = trans.z;
}

/////////////////////////////////////////////////////////////////////////////
// ResetMovements
void CMolecule::ResetMovements(void)
{
  translation.x = 0.0;
  translation.y = 0.0;
  ResetCoordinateSystem();
}

/////////////////////////////////////////////////////////////////////////////
// SetAbsoluteAtomCoordinate
int CMolecule::SetAbsoluteAtomCoordinate(int Atom, int PixelPosX, int PixelPosY, int updateBonds, int View)
{
  // used variables
  float tmpPos1D;
  POINT2D MousePos2D;
  POINT3D ElementPos3D;
  POINT3D tmpElementPos3D;

  if(!usedClientRect.isNull() && NumberOfAtoms > 0)
  {
    // get position of selected element
    ElementPos3D.x = Element[Atom].x;
    ElementPos3D.y = Element[Atom].y;
    ElementPos3D.z = Element[Atom].z;

    // rotate and copy element coordinates to tmp-variables
    if(!execRotation(ElementPos3D, tmpElementPos3D, View)) return(FALSE);

    // get mouse pixel position in molecule coordinates
    MousePos2D = mapFromWidgetPoint(PixelPosX, PixelPosY);

    // consider zoom, perspective and translation to mouse position
    MousePos2D.x /= ZoomFactor;
    MousePos2D.y /= ZoomFactor;
    switch(View)
    {
      case VIEW_RIGHT:
        tmpPos1D = tmpElementPos3D.z + translation.x;
        if(!execInvPerspective(MousePos2D.x, MousePos2D.y, tmpPos1D)) return(FALSE);
        MousePos2D.x += translation.z;
        MousePos2D.y -= translation.y;
        break;
      case VIEW_TOP:
        tmpPos1D = tmpElementPos3D.z + translation.y;
        if(!execInvPerspective(MousePos2D.x, MousePos2D.y, tmpPos1D)) return(FALSE);
        MousePos2D.x -= translation.x;
        MousePos2D.y += translation.z;
        break;
      case VIEW_FRONT:
        tmpPos1D = tmpElementPos3D.z + translation.z;
        if(!execInvPerspective(MousePos2D.x, MousePos2D.y, tmpPos1D)) return(FALSE);
        MousePos2D.x -= translation.x;
        MousePos2D.y -= translation.y;
        break;
      default:
        return(FALSE);
        break;
    }

    // set new coordinate
    tmpElementPos3D.x = MousePos2D.x;
    tmpElementPos3D.y = MousePos2D.y;

    // rotate back
    if(!execInvRotation(tmpElementPos3D, ElementPos3D, View)) return(FALSE);

    // set new coordinates and return
    return(SetAtomCoordinate(Atom, ElementPos3D, updateBonds));
  }
  else
    return(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// Capture
int CMolecule::Capture(int MousePosX, int MousePosY, int View)
{
  int CapturedAtom = -1;
  if(!usedClientRect.isNull() && NumberOfAtoms > 0)
  {
    int i;
    POINT3D MousePos3D;
    POINT2D MousePos2D;
    ELEMENT *tmpElement;

    // create temporary ELEMENT- and INTPOINT2D-fields for usage in this method
    tmpElement = (ELEMENT*) calloc(SizeOfElementField, sizeof(ELEMENT));
    if(tmpElement == NULL) return(CapturedAtom);

    // get mouse position in molecule coordinates
    MousePos2D = mapFromWidgetPoint(MousePosX, MousePosY);
    MousePos3D.x = MousePos2D.x;
    MousePos3D.y = MousePos2D.y;
    MousePos3D.z = 0.0;

    // rotate and translate coordinates
    if(!execRotationTranslation(Element, tmpElement, View)) return(CapturedAtom);

    // calculate element perspective
    if(!execPerspective(tmpElement)) return(CapturedAtom);

    // check if atom captured
    for(i = 0; i < NumberOfAtoms; i++)
    {
      if(RadiusFactor > 0.0 && tmpElement[i].Radius * ZoomFactor * RadiusFactor >= (float)sqrt(pow(MousePos3D.x - tmpElement[i].x * ZoomFactor, 2) + pow(MousePos3D.y - tmpElement[i].y * ZoomFactor, 2)))
      {
        // atom captured, check if max z coordinate found
        if(CapturedAtom == -1)
          CapturedAtom = i;
        else
          if(tmpElement[CapturedAtom].z < tmpElement[i].z) CapturedAtom = i;
      }
    }

    // clean up ...
    free(tmpElement);
  }
  return(CapturedAtom);
}

/////////////////////////////////////////////////////////////////////////////
// mapFromWidgetPoint
POINT2D CMolecule::mapFromWidgetPoint(int posX, int posY)
{
  POINT2D result;
  if(usedClientRect.height() <= usedClientRect.width())
  {
    result.x = MOL_MEASUREMENT * (((float)posX - (((float)usedClientRect.width() - (float)usedClientRect.height()) / 2)) / (float)(usedClientRect.height() == 0 ? 1 : usedClientRect.height()) - 0.5);
    result.y = MOL_MEASUREMENT * ((float)posY / (float)(usedClientRect.height() == 0 ? 1 : usedClientRect.height()) - 0.5);
  }
  else
  {
    result.x = MOL_MEASUREMENT * ((float)posX / (float)(usedClientRect.width() == 0 ? 1 :  usedClientRect.width()) - 0.5);
    result.y = MOL_MEASUREMENT * ((((((float)usedClientRect.height() - (float)usedClientRect.width()) / 2) - (float)posY) / (float)(usedClientRect.width() == 0 ? 1 : usedClientRect.width())) + 0.5);
  }
  return(result);
}

/////////////////////////////////////////////////////////////////////////////
// execRotationTranslation
int CMolecule::execRotationTranslation(ELEMENT *in, ELEMENT *out, int view)
{
  int i;
  memcpy(out, in, SizeOfElementField * sizeof(ELEMENT));

  // rotate and translate molecule structure
  if(view < 1 || view > 3) view = View;
  switch(view)
  {
    case VIEW_RIGHT:
      for(i = 0; i < NumberOfAtoms; i++)
      {
        out[i].x = - translation.z
                   - in[i].x * (cs.GetVector(X_AXIS)).z
                   - in[i].y * (cs.GetVector(Y_AXIS)).z
                   - in[i].z * (cs.GetVector(Z_AXIS)).z;
        out[i].y = translation.y
                   + in[i].x * (cs.GetVector(X_AXIS)).y
                   + in[i].y * (cs.GetVector(Y_AXIS)).y
                   + in[i].z * (cs.GetVector(Z_AXIS)).y;
        out[i].z = translation.x
                   + in[i].x * (cs.GetVector(X_AXIS)).x
                   + in[i].y * (cs.GetVector(Y_AXIS)).x
                   + in[i].z * (cs.GetVector(Z_AXIS)).x;
      }
      break;
    case VIEW_TOP:
      for(i = 0; i < NumberOfAtoms; i++)
      {
        out[i].x = translation.x
                   + in[i].x * (cs.GetVector(X_AXIS)).x
                   + in[i].y * (cs.GetVector(Y_AXIS)).x
                   + in[i].z * (cs.GetVector(Z_AXIS)).x;
        out[i].y = - translation.z
                   - in[i].x * (cs.GetVector(X_AXIS)).z
                   - in[i].y * (cs.GetVector(Y_AXIS)).z
                   - in[i].z * (cs.GetVector(Z_AXIS)).z;
        out[i].z = translation.y
                   + in[i].x * (cs.GetVector(X_AXIS)).y
                   + in[i].y * (cs.GetVector(Y_AXIS)).y
                   + in[i].z * (cs.GetVector(Z_AXIS)).y;
      }
      break;
    case VIEW_FRONT:
      for(i = 0; i < NumberOfAtoms; i++)
      {
        out[i].x = translation.x
                   + in[i].x * (cs.GetVector(X_AXIS)).x
                   + in[i].y * (cs.GetVector(Y_AXIS)).x
                   + in[i].z * (cs.GetVector(Z_AXIS)).x;
        out[i].y = translation.y
                   + in[i].x * (cs.GetVector(X_AXIS)).y
                   + in[i].y * (cs.GetVector(Y_AXIS)).y
                   + in[i].z * (cs.GetVector(Z_AXIS)).y;
        out[i].z = translation.z
                   + in[i].x * (cs.GetVector(X_AXIS)).z
                   + in[i].y * (cs.GetVector(Y_AXIS)).z
                   + in[i].z * (cs.GetVector(Z_AXIS)).z;
      }
      break;
    default:
      return(FALSE);
      break;
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// execRotation
int CMolecule::execRotation(POINT3D &in, POINT3D &out, int view)
{
  // rotate point
  if(view < 1 || view > 3) view = View;
  switch(view)
  {
    case VIEW_RIGHT:
      out.x = - in.x * (cs.GetVector(X_AXIS)).z
              - in.y * (cs.GetVector(Y_AXIS)).z
              - in.z * (cs.GetVector(Z_AXIS)).z;
      out.y = in.x * (cs.GetVector(X_AXIS)).y
              + in.y * (cs.GetVector(Y_AXIS)).y
              + in.z * (cs.GetVector(Z_AXIS)).y;
      out.z = in.x * (cs.GetVector(X_AXIS)).x
              + in.y * (cs.GetVector(Y_AXIS)).x
              + in.z * (cs.GetVector(Z_AXIS)).x;
      break;
    case VIEW_TOP:
      out.x = in.x * (cs.GetVector(X_AXIS)).x
              + in.y * (cs.GetVector(Y_AXIS)).x
              + in.z * (cs.GetVector(Z_AXIS)).x;
      out.y = - in.x * (cs.GetVector(X_AXIS)).z
              - in.y * (cs.GetVector(Y_AXIS)).z
              - in.z * (cs.GetVector(Z_AXIS)).z;
      out.z = in.x * (cs.GetVector(X_AXIS)).y
              + in.y * (cs.GetVector(Y_AXIS)).y
              + in.z * (cs.GetVector(Z_AXIS)).y;
      break;
    case VIEW_FRONT:
      out.x = in.x * (cs.GetVector(X_AXIS)).x
              + in.y * (cs.GetVector(Y_AXIS)).x
              + in.z * (cs.GetVector(Z_AXIS)).x;
      out.y = in.x * (cs.GetVector(X_AXIS)).y
              + in.y * (cs.GetVector(Y_AXIS)).y
              + in.z * (cs.GetVector(Z_AXIS)).y;
      out.z = in.x * (cs.GetVector(X_AXIS)).z
              + in.y * (cs.GetVector(Y_AXIS)).z
              + in.z * (cs.GetVector(Z_AXIS)).z;
      break;
    default:
      return(FALSE);
      break;
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// execInvRotation
int CMolecule::execInvRotation(POINT3D &in, POINT3D &out, int view)
{
  // rotate and translate point
  if(view < 1 || view > 3) view = View;
  switch(view)
  {
    case VIEW_RIGHT:
      out.x = in.z * (cs.GetInverseVector(X_AXIS)).x
              + in.y * (cs.GetInverseVector(Y_AXIS)).x
              - in.x * (cs.GetInverseVector(Z_AXIS)).x;
      out.y = in.z * (cs.GetInverseVector(X_AXIS)).y
              + in.y * (cs.GetInverseVector(Y_AXIS)).y
              - in.x * (cs.GetInverseVector(Z_AXIS)).y;
      out.z = in.z * (cs.GetInverseVector(X_AXIS)).z
              + in.y * (cs.GetInverseVector(Y_AXIS)).z
              - in.x * (cs.GetInverseVector(Z_AXIS)).z;
      break;
    case VIEW_TOP:
      out.x = in.x * (cs.GetInverseVector(X_AXIS)).x
              + in.z * (cs.GetInverseVector(Y_AXIS)).x
              - in.y * (cs.GetInverseVector(Z_AXIS)).x;
      out.y = in.x * (cs.GetInverseVector(X_AXIS)).y
              + in.z * (cs.GetInverseVector(Y_AXIS)).y
              - in.y * (cs.GetInverseVector(Z_AXIS)).y;
      out.z = in.x * (cs.GetInverseVector(X_AXIS)).z
              + in.z * (cs.GetInverseVector(Y_AXIS)).z
              - in.y * (cs.GetInverseVector(Z_AXIS)).z;
      break;
    case VIEW_FRONT:
      out.x = in.x * (cs.GetInverseVector(X_AXIS)).x
              + in.y * (cs.GetInverseVector(Y_AXIS)).x
              + in.z * (cs.GetInverseVector(Z_AXIS)).x;
      out.y = in.x * (cs.GetInverseVector(X_AXIS)).y
              + in.y * (cs.GetInverseVector(Y_AXIS)).y
              + in.z * (cs.GetInverseVector(Z_AXIS)).y;
      out.z = in.x * (cs.GetInverseVector(X_AXIS)).z
              + in.y * (cs.GetInverseVector(Y_AXIS)).z
              + in.z * (cs.GetInverseVector(Z_AXIS)).z;
      break;
    default:
      return(FALSE);
      break;
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// TranslateAbsolute
void CMolecule::TranslateAbsolute(int DeltaPixelPosX, int DeltaPixelPosY, int View)
{
  POINT2D deltaTranslation;

  if(usedClientRect.height() <= usedClientRect.width())
  {
    deltaTranslation.x = (float)MOL_MEASUREMENT * (float)DeltaPixelPosX / (usedClientRect.height() == 0 ? 1 : usedClientRect.height());
    deltaTranslation.y = (float)MOL_MEASUREMENT * (float)DeltaPixelPosY / (usedClientRect.height() == 0 ? 1 : usedClientRect.height());
  }
  else
  {
    deltaTranslation.x = (float)MOL_MEASUREMENT * (float)DeltaPixelPosX / (usedClientRect.width() == 0 ? 1 : usedClientRect.width());
    deltaTranslation.y = (float)MOL_MEASUREMENT * (float)DeltaPixelPosY / (usedClientRect.width() == 0 ? 1 : usedClientRect.width());
  }

  switch(View)
  {
    case VIEW_RIGHT:
      translation.z -= deltaTranslation.x;
      translation.y += deltaTranslation.y;
      break;
    case VIEW_TOP:
      translation.x += deltaTranslation.x;
      translation.z -= deltaTranslation.y;
      break;
    case VIEW_FRONT:
      translation.x += deltaTranslation.x;
      translation.y += deltaTranslation.y;
      break;
  }
}

/////////////////////////////////////////////////////////////////////////////
// calcPerspective
float CMolecule::calcPerspective(float &PosZ)
{
  float result = 1.0;
  if(MaxAtomCenterDistance > 0.0 && PerspectiveFactor >= 0.0)
    result = 1.0 + PosZ / (1.5 * MaxAtomCenterDistance * (MAX_PERSPECTIVEFACTOR / (PerspectiveFactor + 1)));
  return(result);
}

/////////////////////////////////////////////////////////////////////////////
// execPerspective
int CMolecule::execPerspective(ELEMENT *elements)
{
  int i;
  float tmpFactor;
  for(i = 0; i < NumberOfAtoms; i++)
  {
    tmpFactor = calcPerspective(elements[i].z);
    elements[i].Radius *= tmpFactor;
    elements[i].x *= tmpFactor;
    elements[i].y *= tmpFactor;
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// execInvPerspective
int CMolecule::execInvPerspective(float &posX, float &posY, float &posZ)
{
  float tmpFactor;
  tmpFactor = calcPerspective(posZ);
  posX /= tmpFactor;
  posY /= tmpFactor;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// sortAtoms
int CMolecule::sortAtoms(ELEMENT *elements, INTPOINT2D *bonds)
{
  int i;
  int j;
  int k;
  ELEMENT bufferEl;
  long bufferBond;
  int ElNr_min;

  for(i = 0; i < NumberOfAtoms - 1; i++)
  {
    ElNr_min = i;
    for(j = i + 1; j < NumberOfAtoms ; j++)
    {
      if(elements[j].z < elements[ElNr_min].z)
        ElNr_min = j;
    }

    if(ElNr_min != i)
    {
      // change atoms
      bufferEl = elements[i];
      elements[i] = elements[ElNr_min];
      elements[ElNr_min] = bufferEl;

      // actualisize bonds
      for(k = 0; k < NumberOfBonds; k++)
      {
        if(bonds[k].x == i)
          bonds[k].x = ElNr_min;
        else
        {
          if(bonds[k].x == ElNr_min)
            bonds[k].x = i;
        }

        if(bonds[k].y == i)
          bonds[k].y = ElNr_min;
        else
        {
          if(bonds[k].y == ElNr_min)
            bonds[k].y = i;
        }

        if(bonds[k].x > bonds[k].y)
        {
          bufferBond = bonds[k].x;
          bonds[k].x = bonds[k].y;
          bonds[k].y = bufferBond;
        }
      }
    }
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DrawStructure
int CMolecule::DrawStructure(QPaintDevice *pdev, const QRect &rectClient)
{
  // return imediately under the following conditions
  if(pdev == NULL) return(FALSE);
  if((rectClient.width() <= 0) || (rectClient.height() <= 0)) return(FALSE);

  // for counting
  int i, j, k;

  // save parameter for mapFromWidgetSize
  usedClientRect = rectClient;

  // create temporary ELEMENT- and INTPOINT2D-fields for usage in this method
  ELEMENT *tmpElement;
  INTPOINT2D *tmpBondPartners;
  tmpElement = (ELEMENT*) calloc(SizeOfElementField, sizeof(ELEMENT));
  if(tmpElement == NULL)
  {
    return(FALSE);
  }
  tmpBondPartners = (INTPOINT2D*) calloc(SizeOfBondPartnersField, sizeof(INTPOINT2D));
  if(tmpBondPartners == NULL)
  {
    free(tmpElement);
    return(FALSE);
  }

  // copy BondPartners data to tmpElement and tmpBondPartners
  memcpy(tmpBondPartners, BondPartners, SizeOfBondPartnersField * sizeof(INTPOINT2D));

  // rotate molecule and copy coordinates to tmp-variables
  if(!execRotationTranslation(Element, tmpElement)) return(FALSE);

  // sort atoms with increasing z-value
  if(!sortAtoms(tmpElement, tmpBondPartners)) return(FALSE);

  // calculate perspective and translation
  if(!execPerspective(tmpElement)) return(FALSE);

  // draw structure
  QPixmap pix(rectClient.size());
  QPainter p;
  // if type of pdev != Printer
  if(pdev->devType() != QInternal::Printer) p.begin(&pix);
  // if type of pdev == Printer
  else p.begin(pdev);
  p.eraseRect(rectClient);
  p.fillRect(rectClient, QBrush(bgColor));

  // set window
  float pDevMeasurement;
  pDevMeasurement = (rectClient.height() <= rectClient.width() ? rectClient.height() : rectClient.width());
  p.setWindow(-rectClient.width() / 2,
              -rectClient.height() / 2,
               rectClient.width(),
               rectClient.height());

  p.setPen(QPen(Qt::black, 1, Qt::SolidLine));
  p.setBrush(QBrush(Qt::black));

  // draw atoms
  QString buffer = "";

  for(i = 0; i < NumberOfAtoms; i++)
  {
    // change Radius with RadiusFactor
    tmpElement[i].Radius = tmpElement[i].Radius * RadiusFactor;

    if(tmpElement[i].Pattern != Qt::SolidPattern)
    {
      p.setBrush(QColor(255, 255, 255));
      p.drawEllipse(int((tmpElement[i].x - tmpElement[i].Radius) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                    int((-tmpElement[i].y - tmpElement[i].Radius) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                    int(tmpElement[i].Radius * ZoomFactor * pDevMeasurement / (MOL_MEASUREMENT / 2)),
                    int(tmpElement[i].Radius * ZoomFactor * pDevMeasurement / (MOL_MEASUREMENT / 2)));
    }
    p.setBrush(QBrush(tmpElement[i].Color, (BrushStyle)tmpElement[i].Pattern));
    p.drawEllipse(int((tmpElement[i].x - tmpElement[i].Radius) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                  int((-tmpElement[i].y - tmpElement[i].Radius) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                  int(tmpElement[i].Radius * ZoomFactor * pDevMeasurement / (MOL_MEASUREMENT / 2)),
                  int(tmpElement[i].Radius * ZoomFactor * pDevMeasurement / (MOL_MEASUREMENT / 2)));


    // set Label
    switch(LabelType)
    {
      case LB_NOLABEL:
        continue;
      case LB_ATOMSYMBOL:
        p.setFont(QFont("helvetica", 12, 50));
        p.drawText(int((tmpElement[i].x - tmpElement[i].Radius * 0.5) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   int(-tmpElement[i].y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   pse.GetSymbol(tmpElement[i].OrdinalNumber));
        continue;
      case LB_ORDINALNUMBER:
        p.setFont(QFont("helvetica", 12, 50));
        buffer.setNum(tmpElement[i].OrdinalNumber);
        p.drawText(int((tmpElement[i].x - tmpElement[i].Radius * 0.5) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   int(-tmpElement[i].y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   buffer);
        continue;
      case LB_USER:
        p.setFont(QFont("helvetica", 12, 50));
        buffer.setNum(tmpElement[i].Label);
        p.drawText(int((tmpElement[i].x - tmpElement[i].Radius * 0.5) * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   int(-tmpElement[i].y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   buffer);
        continue;
    }
  }

  // draw bonds
  if(NumberOfBonds > 0)
  {
    p.setPen(QPen(BondColor, 2));
    int Atom1, Atom2;
    for(i = 0; i < NumberOfBonds; i++)
    {
      Atom1 = tmpBondPartners[i].x;
      Atom2 = tmpBondPartners[i].y;

      float DX = tmpElement[Atom2].x - tmpElement[Atom1].x;
      float DY = -tmpElement[Atom2].y + tmpElement[Atom1].y;
      float DZ = tmpElement[Atom2].z - tmpElement[Atom1].z;

      float Distance2D = (float)sqrt(pow(DX, 2) + pow(DY, 2));

      float Distance3D = (float)sqrt(pow(DX, 2) + pow(DY, 2) + pow(DZ, 2));

      // begin of the bond
      POINT3D Start;

      Start.x = tmpElement[Atom1].x +
            tmpElement[Atom1].Radius * DX / Distance3D;
      Start.y = - tmpElement[Atom1].y +
            tmpElement[Atom1].Radius * DY / Distance3D;
      Start.z = tmpElement[Atom1].z +
            tmpElement[Atom1].Radius * DZ / Distance3D;

      // 1st case:
      // bond is completly covered by Atom2
      // => no bond to draw
      if(tmpElement[Atom2].Radius >= (float)sqrt(pow(tmpElement[Atom2].x - Start.x, 2) + pow(-tmpElement[Atom2].y - Start.y, 2)))
        continue;

      // 2nd case:
      // Atom1 touches Atom2
      // => no bond to draw
      if((RadiusFactor * (tmpElement[Atom2].Radius + tmpElement[Atom1].Radius)) >= Distance3D) continue;

      // check all atoms laying in front of Atom1 (z > z1)
      int InFrontOfAtom1AndAtom2 = FALSE;
      for(j = Atom1 + 1; j < NumberOfAtoms; j++)
      {
        if(j == Atom2) continue;

        if((DX > 0) && (DY > 0))
        {
          if(((tmpElement[Atom1].x - tmpElement[j].Radius) <= tmpElement[j].x) &&
             ((tmpElement[Atom2].x + tmpElement[j].Radius) >= tmpElement[j].x) &&
             ((-tmpElement[Atom1].y - tmpElement[j].Radius) <= -tmpElement[j].y) &&
             ((-tmpElement[Atom2].y + tmpElement[j].Radius) >= -tmpElement[j].y))
          {
            InFrontOfAtom1AndAtom2 = TRUE;
            j = NumberOfAtoms;
          }
          continue;
        }
        if((DX > 0) && (DY < 0))
        {
          if(((tmpElement[Atom1].x - tmpElement[j].Radius) <= tmpElement[j].x) &&
             ((tmpElement[Atom2].x + tmpElement[j].Radius) >= tmpElement[j].x) &&
             ((-tmpElement[Atom1].y + tmpElement[j].Radius) >= -tmpElement[j].y) &&
             ((-tmpElement[Atom2].y - tmpElement[j].Radius) <= -tmpElement[j].y))
          {
            InFrontOfAtom1AndAtom2 = TRUE;
            j = NumberOfAtoms;
          }
          continue;
        }
        if((DX < 0) && (DY > 0))
        {
          if(((tmpElement[Atom1].x + tmpElement[j].Radius) >= tmpElement[j].x) &&
             ((tmpElement[Atom2].x - tmpElement[j].Radius) <= tmpElement[j].x) &&
             ((-tmpElement[Atom1].y - tmpElement[j].Radius) <= -tmpElement[j].y) &&
             ((-tmpElement[Atom2].y + tmpElement[j].Radius) >= -tmpElement[j].y))
          {
            InFrontOfAtom1AndAtom2 = TRUE;
            j = NumberOfAtoms;
          }
          continue;
        }
        if(((tmpElement[Atom1].x + tmpElement[j].Radius) >= tmpElement[j].x) &&
           ((tmpElement[Atom2].x - tmpElement[j].Radius) <= tmpElement[j].x) &&
           ((-tmpElement[Atom1].y + tmpElement[j].Radius) >= -tmpElement[j].y) &&
           ((-tmpElement[Atom2].y - tmpElement[j].Radius) <= -tmpElement[j].y))
          {
            InFrontOfAtom1AndAtom2 = TRUE;
            j = NumberOfAtoms;
          }
      }

      // end of the bond
      POINT3D End;

      End.x = tmpElement[Atom2].x - tmpElement[Atom2].Radius * DX / Distance2D;
      End.y = -tmpElement[Atom2].y - tmpElement[Atom2].Radius * DY / Distance2D;
      End.z = tmpElement[Atom2].z - tmpElement[Atom2].Radius * DZ / Distance3D;

      if(InFrontOfAtom1AndAtom2 == FALSE)
      {
        // 3rd case:
        // in the room between Atom1 and Atom2 are no other atoms
        p.drawLine(int(Start.x * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   int(Start.y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   int(End.x * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                   int(End.y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT));
      }
      else
      {
        // 4th case:
        // in the room between Atom1 and Atom2 are other atoms
        float lambda;
        POINT3D PointOfBond;
        POINT3D IntermediateStart, IntermediateEnd;

        IntermediateStart.x = Start.x;
        IntermediateStart.y = Start.y;
        IntermediateStart.z = Start.z;
        IntermediateEnd.x = Start.x;
        IntermediateEnd.y = Start.y;
        IntermediateEnd.z = Start.z;

        int DrawPixel = FALSE;
        int DrawPixelOld = FALSE;

        float NumberOfPixel = (float)sqrt(pow((tmpElement[Atom2].x * ZoomFactor * 0.1 * rectClient.width()
                                             - tmpElement[Atom1].x * ZoomFactor * 0.1 * rectClient.width()),2) +
                                          pow((-tmpElement[Atom2].y * ZoomFactor * 0.1 * rectClient.height()
                                             + tmpElement[Atom1].y * ZoomFactor * 0.1 * rectClient.height()),2));

        for(j = 0; j <= int(NumberOfPixel); j++)
        {
          // lambda increases from 0.0 to 1.0
          lambda = (float)j / NumberOfPixel;

          PointOfBond.x = Start.x + lambda * (End.x - Start.x);
          PointOfBond.y = Start.y + lambda * (End.y - Start.y);
          PointOfBond.z = Start.z + lambda * (End.z - Start.z);

          DrawPixelOld = DrawPixel;

          for(k = 0; k < NumberOfAtoms; k++)
          {
            if((float)sqrt(pow(PointOfBond.x - tmpElement[k].x,2) +
                           pow(PointOfBond.y + tmpElement[k].y,2)) <=
                      tmpElement[k].Radius)
            {
              if(PointOfBond.z >= tmpElement[k].z)
              {
                // Atom lies behind the point
                if((float)sqrt(pow(PointOfBond.x - tmpElement[k].x,2) +
                               pow(PointOfBond.y + tmpElement[k].y,2) +
                               pow(PointOfBond.z - tmpElement[k].z,2)) <=
                          tmpElement[k].Radius)
                {
                  DrawPixel = FALSE;
                  k = NumberOfAtoms;
                }
                else
                {
                  DrawPixel = TRUE;
                }
              }
              else
              {
                // Atom lies in front of the point or at the same depth
                DrawPixel = FALSE;
                k = NumberOfAtoms;
              }
            }
            else
            {
              DrawPixel = TRUE;
            }
          }

          if(DrawPixelOld != DrawPixel)
          {
            if(DrawPixel)
            {
              IntermediateStart.x = PointOfBond.x;
              IntermediateStart.y = PointOfBond.y;
            }
            else
            {
              IntermediateEnd.x = PointOfBond.x;
              IntermediateEnd.y = PointOfBond.y;

              p.drawLine(int(IntermediateStart.x * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                         int(IntermediateStart.y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                         int(IntermediateEnd.x * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                         int(IntermediateEnd.y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT));
            }
          }
        }
        if(DrawPixel)
        {
          IntermediateEnd.x = PointOfBond.x;
          IntermediateEnd.y = PointOfBond.y;
          p.drawLine(int(IntermediateStart.x * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                     int(IntermediateStart.y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                     int(IntermediateEnd.x * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT),
                     int(IntermediateEnd.y * ZoomFactor * pDevMeasurement / MOL_MEASUREMENT));
        }
      }
    }
  }
  if(pdev->devType() != QInternal::Printer)
  {
    // copy pixmap if type of pdev != Printer
    p.flush();
    bitBlt(pdev, 0, 0, &pix);
  }
  p.end();

  // clean up and return
  free(tmpElement);
  free(tmpBondPartners);
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// InitMolecule
int CMolecule::InitMolecule(void)
{
  // initialisations
  BondFudge = (float)DEFAULT_BONDFUDGE;
  BondColor = (QColor)DEFAULT_BONDCOLOR;
  ResetCoordinateSystem();
  Title = "";
  usedClientRect.setRight(0);
  usedClientRect.setLeft(1);
  usedClientRect.setBottom(0);
  usedClientRect.setTop(1);
  translation.x = 0.0;
  translation.y = 0.0;
  translation.z = 0.0;
  PerspectiveFactor = (float)DEFAULT_PERSPECTIVEFACTOR;
  MaxAtomCenterDistance = 0.0;
  ZoomFactor = (float)DEFAULT_ZOOMFACTOR;
  RadiusFactor = (float)DEFAULT_RADIUSFACTOR;
  LabelType = DEFAULT_LABELTYPE;
  View = DEFAULT_VIEW;
  bgColor = (QColor)DEFAULT_BGCOLOR;

  return(DeleteMolecule());
}

/////////////////////////////////////////////////////////////////////////////
// DeleteMolecule
int CMolecule::DeleteMolecule()
{
  if(Element != NULL)
  {
    free(Element);
    Element = 0;
  }
  NumberOfAtoms = 0;
  SizeOfElementField = 1;
  Element = (ELEMENT*) calloc(SizeOfElementField, sizeof(ELEMENT));
  if(Element == NULL) return(FALSE);
  help_Element = Element;

  if(BondPartners != NULL)
  {
    free(BondPartners);
    BondPartners = 0;
  }
  NumberOfBonds = 0;
  SizeOfBondPartnersField = 1;
  BondPartners = (INTPOINT2D*) calloc(SizeOfBondPartnersField, sizeof(INTPOINT2D));
  if(BondPartners == NULL)
  {
    if(Element != NULL)
    {
      free(Element);
      Element = 0;
    }
    return(FALSE);
  }
  help_BondPartners = BondPartners;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// AddAtom
int CMolecule::AddAtom(ELEMENT El, int MakeBonds)
{
  int i = 0;
  float tmpAtomCenterDistance = 0.0;
  
  // check if Label is in use
  for(i = 0; i < NumberOfAtoms; i++)
  {
    if(El.Label == Element[i].Label) return(FALSE);
  }

  // add new Element
  SizeOfElementField++;
  Element = (ELEMENT*) realloc(Element, SizeOfElementField * sizeof(ELEMENT));
  help_Element = Element;
  if(Element != NULL)
  {
    help_Element += NumberOfAtoms;
    *help_Element = El;
    NumberOfAtoms++;
  }
  else
  {
    return(FALSE);
  }

  // calculate bonds and add them if MakeBonds == TRUE
  if(MakeBonds && NumberOfAtoms > 1)
  {
    float Distance2D = 0.0;
    float MaxBondDistance = 0.0;
    for(i = 0; i < NumberOfAtoms - 1; i++)
    {
      Distance2D = (float)sqrt(pow((Element[i].x - El.x), 2) +
                               pow((Element[i].y - El.y), 2) +
                               pow((Element[i].z - El.z), 2));
      MaxBondDistance = (Element[i].Radius + El.Radius) * BondFudge;
      if(Distance2D <= MaxBondDistance)
      {
        // bond found
        SizeOfBondPartnersField++;
        BondPartners = (INTPOINT2D*) realloc(BondPartners, SizeOfBondPartnersField * sizeof(INTPOINT2D));
        help_BondPartners = BondPartners;
        if(BondPartners != NULL)
        {
          help_BondPartners += NumberOfBonds;
          help_BondPartners->x = i;
          help_BondPartners->y = NumberOfAtoms - 1;
          NumberOfBonds++;
        }
        else
        {
          return(FALSE);
        }
      }
    }
  }

  // calculate maxium distance between atom and center (0.0, 0.0, 0.0)  
  tmpAtomCenterDistance = (float)sqrt(pow(El.x, 2) + pow(El.y, 2) + pow(El.z, 2));
  MaxAtomCenterDistance = (tmpAtomCenterDistance > MaxAtomCenterDistance ? tmpAtomCenterDistance : MaxAtomCenterDistance);

  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DeleteAtom
int CMolecule::DeleteAtom(int Atom)
{
  int i = 0;
  INTPOINT2D tmpBP;

  if(NumberOfAtoms < 1) return(FALSE);
  if((Atom < 0) || (Atom > NumberOfAtoms - 1)) return(FALSE);

  // delete bonds
  if(NumberOfBonds > 0)
  {
    i = -1;
    do
    {
      i++;
      tmpBP = BondPartners[i];
      if(tmpBP.x == Atom)
      {
        if(DeleteBond(Atom, tmpBP.y) == FALSE) return(FALSE);
        i = -1;
      }

      if((tmpBP.y == Atom) && (tmpBP.x != Atom))
      {
        if(DeleteBond(tmpBP.x, Atom) == FALSE) return(FALSE);
        i = -1;
      }
    } while(i < NumberOfBonds - 1);
  }

  // delete Element
  help_Element = Element;

  for(i = Atom; i < NumberOfAtoms; i++)
  {
    help_Element = Element + i;
    *help_Element = Element[i + 1];
  }

  SizeOfElementField--;
  if(SizeOfElementField > 0)
  {
    Element = (ELEMENT*) realloc(Element, SizeOfElementField * sizeof(ELEMENT));
    help_Element = Element;
    if(Element == NULL) return(FALSE);
    NumberOfAtoms--;
  }
  else
  {
    free(Element);
    Element = (ELEMENT*) calloc(SizeOfElementField, sizeof(ELEMENT));
    help_Element = Element;
    if(Element == NULL) return(FALSE);
    NumberOfAtoms--;
  }

  // correct number of atoms in the bond partner field
  for(i = 0; i < NumberOfBonds; i++)
  {
    if(BondPartners[i].x > Atom) BondPartners[i].x--;
    if(BondPartners[i].y > Atom) BondPartners[i].y--;
  }

  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DeleteAtomByLabel
int CMolecule::DeleteAtomByLabel(int LabelAtom)
{
  if(NumberOfAtoms < 1) return(FALSE);

  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(Element[i].Label == LabelAtom)
    {
      return DeleteAtom(i);
    }
  }
  return(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// AddBond
int CMolecule::AddBond(int Atom1, int Atom2)
{
  if(Atom1 == Atom2) return(FALSE);
  if(NumberOfAtoms < 2) return(FALSE);
  if((Atom1 < 0) || (Atom1 > NumberOfAtoms - 1)) return(FALSE);
  if((Atom2 < 0) || (Atom2 > NumberOfAtoms - 1)) return(FALSE);

  if(Atom1 > Atom2)
  {
    int tmpAtom = Atom1;
    Atom1 = Atom2;
    Atom2 = tmpAtom;
  }

  for(int i = 1; i < NumberOfBonds; i++)
  {
    if((BondPartners[i].x == Atom1) && (BondPartners[i].y == Atom2)) return(FALSE);
  }

  SizeOfBondPartnersField++;
  BondPartners = (INTPOINT2D*) realloc(BondPartners, SizeOfBondPartnersField * sizeof(INTPOINT2D));
  help_BondPartners = BondPartners;
  if(BondPartners != NULL)
  {
    help_BondPartners += NumberOfBonds;
    help_BondPartners->x = Atom1;
    help_BondPartners->y = Atom2;
    NumberOfBonds++;
    return(TRUE);
  }
  else
  {
    SizeOfBondPartnersField--;
    return(FALSE);
  }
}

/////////////////////////////////////////////////////////////////////////////
// AddBondByLabels
int CMolecule::AddBondByLabels(int LabelAtom1, int LabelAtom2)
{
  if(LabelAtom1 == LabelAtom2) return(FALSE);
  if(NumberOfAtoms < 2) return(FALSE);

  int AtomNumber1 = -1;
  int AtomNumber2 = -1;
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(Element[i].Label == LabelAtom1) AtomNumber1 = i;
    if(Element[i].Label == LabelAtom2) AtomNumber2 = i;
  }

  if((AtomNumber1 == -1) || (AtomNumber2 == -1))
  {
    return(FALSE);
  }
  else
  {
    return AddBond(AtomNumber1, AtomNumber2);
  }

  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DeleteBond
int CMolecule::DeleteBond(int Atom1, int Atom2)
{
  if(Atom1 == Atom2) return(FALSE);
  if(NumberOfBonds <= 0) return(FALSE);
  if(NumberOfAtoms < 2) return(FALSE);
  if((Atom1 < 0) || (Atom1 > NumberOfAtoms - 1)) return(FALSE);
  if((Atom2 < 0) || (Atom2 > NumberOfAtoms - 1)) return(FALSE);

  if(Atom1 > Atom2)
  {
    int tmpAtom = Atom1;
    Atom1 = Atom2;
    Atom2 = tmpAtom;
  }

  int i = 0;
  int DeleteNumber = -1;
  for(i = 0; i < NumberOfBonds; i++)
    if((Atom1 == BondPartners[i].x) && (Atom2 == BondPartners[i].y)) DeleteNumber = i;

  if(DeleteNumber != -1)
  {
    help_BondPartners = BondPartners;

    for(i = DeleteNumber; i < NumberOfBonds; i++)
    {
      help_BondPartners = BondPartners + i;
      *help_BondPartners = BondPartners[i + 1];
    }

    SizeOfBondPartnersField--;
    if(SizeOfBondPartnersField > 0)
    {
      BondPartners = (INTPOINT2D*) realloc(BondPartners, SizeOfBondPartnersField * sizeof(INTPOINT2D));
      help_BondPartners = BondPartners;
      if(BondPartners == NULL) return(FALSE);
      NumberOfBonds--;
    }
    else
    {
      free(BondPartners);
      BondPartners = (INTPOINT2D*) calloc(SizeOfBondPartnersField, sizeof(INTPOINT2D));
      help_BondPartners = BondPartners;
      if(BondPartners == NULL) return(FALSE);
      NumberOfBonds--;
    }
  }
  else
    return(FALSE);

  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DeleteBondByLabels
int CMolecule::DeleteBondByLabels(int LabelAtom1, int LabelAtom2)
{
  if(LabelAtom1 == LabelAtom2) return(FALSE);
  if(NumberOfAtoms < 2) return(FALSE);

  int AtomNumber1 = -1;
  int AtomNumber2 = -1;
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(Element[i].Label == LabelAtom1) AtomNumber1 = i;
    if(Element[i].Label == LabelAtom2) AtomNumber2 = i;
  }

  if((AtomNumber1 == -1) || (AtomNumber2 == -1))
  {
    return(FALSE);
  }
  else
  {
    return DeleteBond(AtomNumber1, AtomNumber2);
  }

  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// GetCoordinateSystem
POINT3D CMolecule::GetCoordinateSystem(int axis)
{
  return(cs.GetVector(axis));
}

/////////////////////////////////////////////////////////////////////////////
// GetMatrix
float CMolecule::GetMatrix(int axis, int component)
{
  return(cs.GetMatrix(axis, component));
}

/////////////////////////////////////////////////////////////////////////////
// GetTranslation
POINT3D CMolecule::GetTranslation(void)
{
  return(translation);
}

/////////////////////////////////////////////////////////////////////////////
// GetAtomCoordinate
POINT3D CMolecule::GetAtomCoordinate(int Atom, int ConsiderRotation, int ConsiderTranslation)
{
  POINT3D result;
  if((Atom >= 0) && (Atom < NumberOfAtoms))
  {
    result.x = Element[Atom].x;
    result.y = Element[Atom].y;
    result.z = Element[Atom].z;

    if(ConsiderRotation)
    {
      result.x = Element[Atom].x * (cs.GetVector(X_AXIS)).x
               + Element[Atom].y * (cs.GetVector(Y_AXIS)).x
               + Element[Atom].z * (cs.GetVector(Z_AXIS)).x;
      result.y = Element[Atom].x * (cs.GetVector(X_AXIS)).y
               + Element[Atom].y * (cs.GetVector(Y_AXIS)).y
               + Element[Atom].z * (cs.GetVector(Z_AXIS)).y;
      result.z = Element[Atom].x * (cs.GetVector(X_AXIS)).z
               + Element[Atom].y * (cs.GetVector(Y_AXIS)).z
               + Element[Atom].z * (cs.GetVector(Z_AXIS)).z;
    }

    if(ConsiderTranslation)
    {
        result.x = (ConsiderRotation ? result.x : Element[Atom].x) + translation.x;
        result.y = (ConsiderRotation ? result.y : Element[Atom].y) + translation.y;
        result.z = (ConsiderRotation ? result.z : Element[Atom].z) + translation.z;
    }

    return result;
  }
  else
  {
    result.x = (float)0;
    result.y = (float)0;
    result.z = (float)0;
    return result;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetBond
INTPOINT2D CMolecule::GetBond(int Bond)
{
  INTPOINT2D result;
  if((Bond >= 0) && (Bond < NumberOfBonds))
  {
    result.x = BondPartners[Bond].x;
    result.y = BondPartners[Bond].y;
    return result;
  }
  else
  {
    result.x = 0;
    result.y = 0;
    return result;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetOrdinalNumber
int CMolecule::GetOrdinalNumber(int Atom)
{
  if((Atom >= 0) && (Atom < NumberOfAtoms))
  {
    return Element[Atom].OrdinalNumber;
  }
  else
  {
    return 0;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetLabel
int CMolecule::GetLabel(int Atom)
{
  if((Atom >= 0) && (Atom < NumberOfAtoms))
  {
    return Element[Atom].Label;
  }
  else
  {
    return -1;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetAtomNumberByLabel
int CMolecule::GetAtomNumberByLabel(int LabelAtom)
{
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(Element[i].Label == LabelAtom) return i;
  }
  return -1;
}

/////////////////////////////////////////////////////////////////////////////
// GetRadius
float CMolecule::GetRadius(int Atom)
{
  if((Atom >= 0) && (Atom < NumberOfAtoms))
  {
    return Element[Atom].Radius;
  }
  else
  {
    return (float)0;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetColor
QColor CMolecule::GetColor(int Atom)
{
  if((Atom >= 0) && (Atom < NumberOfAtoms))
  {
    return Element[Atom].Color;
  }
  else
  {
    return (uint)0;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetPattern
int CMolecule::GetPattern(int Atom)
{
  if((Atom >= 0) && (Atom < NumberOfAtoms))
  {
    return Element[Atom].Pattern;
  }
  else
  {
    return Qt::SolidPattern;
  }
}

/////////////////////////////////////////////////////////////////////////////
// GetTitle
QString CMolecule::GetTitle(void)
{
  return Title;
}

/////////////////////////////////////////////////////////////////////////////
// GetNumberOfAtoms
int CMolecule::GetNumberOfAtoms(void)
{
  return NumberOfAtoms;
}

/////////////////////////////////////////////////////////////////////////////
// GetNumberOfBonds
int CMolecule::GetNumberOfBonds(void)
{
  return NumberOfBonds;
}

/////////////////////////////////////////////////////////////////////////////
// GetRadiusFactor
float CMolecule::GetRadiusFactor(void)
{
  return RadiusFactor;
}

/////////////////////////////////////////////////////////////////////////////
// GetPerspectiveFactor
float CMolecule::GetPerspectiveFactor(void)
{
  return PerspectiveFactor;
}

/////////////////////////////////////////////////////////////////////////////
// GetZoomFactor
float CMolecule::GetZoomFactor(void)
{
  return ZoomFactor;
}

/////////////////////////////////////////////////////////////////////////////
// GetLabelType
int CMolecule::GetLabelType(void)
{
  return LabelType;
}

/////////////////////////////////////////////////////////////////////////////
// GetView
int CMolecule::GetView(void)
{
  return View;
}

/////////////////////////////////////////////////////////////////////////////
// GetBondFudge
float CMolecule::GetBondFudge(void)
{
  return BondFudge;
}

/////////////////////////////////////////////////////////////////////////////
// GetBondColor
QColor CMolecule::GetBondColor(void)
{
  return BondColor;
}

/////////////////////////////////////////////////////////////////////////////
// GetBackgroundColorGL
QColor CMolecule::GetBackgroundColor(void)
{
  return(bgColor);
}

/////////////////////////////////////////////////////////////////////////////
// SetMatrix
int CMolecule::SetMatrix(float ix, float iy, float iz,
                         float jx, float jy, float jz,
                         float kx, float ky, float kz,
                         int correctErrors)
{
  return(cs.SetMatrix(ix, iy, iz, jx, jy, jz, kx, ky, kz, correctErrors));
}

/////////////////////////////////////////////////////////////////////////////
// SetAtomCoordinate
int CMolecule::SetAtomCoordinate(int Atom, POINT3D NewCoordinate, int updateBonds)
{
  if((Atom < 0) || (Atom >= NumberOfAtoms)) return(FALSE);
  int result = TRUE;
  Element[Atom].x = NewCoordinate.x;
  Element[Atom].y = NewCoordinate.y;
  Element[Atom].z = NewCoordinate.z;
  // add / delete bonds if updateBonds != 0
  if(updateBonds != 0)
  {
    float Distance2D = 0.0;
    float MaxBondDistance = 0.0;
    for(int i = 0; i < NumberOfAtoms && result; i++)
    {
      if(i == Atom) continue;
      Distance2D = (float)sqrt(pow((Element[i].x - Element[Atom].x),2) +
                               pow((Element[i].y - Element[Atom].y),2) +
                               pow((Element[i].z - Element[Atom].z),2));
      MaxBondDistance = (Element[i].Radius + Element[Atom].Radius) * BondFudge;

      if(Distance2D <= MaxBondDistance)
      {
        // connect
        result = AddBond(i, Atom);
      }
      else
      {
        // disconnect
				for(int j = 0; j < NumberOfBonds; j++)
				{
          if((BondPartners[j].x == i && BondPartners[j].y == Atom) ||
             (BondPartners[j].y == i && BondPartners[j].x == Atom))
          {
            result = DeleteBond(i, Atom);
            break;
          }
          else
            result = TRUE;				
				}
      }
    }
  }
  return result;
}

/////////////////////////////////////////////////////////////////////////////
// SetTranslation
int CMolecule::SetTranslation(float transX, float transY, float transZ)
{
  Translate(transX, transY, transZ);
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetOrdinalNumber
int CMolecule::SetOrdinalNumber(int Atom, int NewOrdinalNumber)
{
  if((Atom < 0) || (Atom >= NumberOfAtoms)) return(FALSE);
  if((NewOrdinalNumber < 1) || (NewOrdinalNumber > 109)) return(FALSE);
  Element[Atom].OrdinalNumber = NewOrdinalNumber;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetLabel
int CMolecule::SetLabel(int Atom, int NewLabel)
{
  if((Atom < 0) || (Atom >= NumberOfAtoms)) return(FALSE);
  // Prfen, ob Label schon vergeben wurde
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(NewLabel == Element[i].Label) return(FALSE);
  }
  Element[Atom].Label = NewLabel;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetRadius
int CMolecule::SetRadius(int Atom, float NewRadius)
{
  if((Atom < 0) || (Atom >= NumberOfAtoms)) return(FALSE);
  Element[Atom].Radius = NewRadius;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetRadius
int CMolecule::SetRadius(float NewRadius)
{
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(!SetRadius(i, NewRadius)) return(FALSE);
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetColor
int CMolecule::SetColor(int Atom, QColor NewColor)
{
  if((Atom < 0) || (Atom >= NumberOfAtoms)) return(FALSE);
  Element[Atom].Color = NewColor;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetColor
int CMolecule::SetColor(QColor NewColor)
{
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(!SetColor(i, NewColor)) return(FALSE);
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetPattern
int CMolecule::SetPattern(int Atom, int NewPattern)
{
  if((Atom < 0) || (Atom >= NumberOfAtoms)) return(FALSE);
  Element[Atom].Pattern = NewPattern;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetPattern
int CMolecule::SetPattern(int NewPattern)
{
  for(int i = 0; i < NumberOfAtoms; i++)
  {
    if(!SetPattern(i, NewPattern)) return(FALSE);
  }
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetTitle
int CMolecule::SetTitle(QString NewTitle)
{
  Title = NewTitle;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetRadiusFactor
int CMolecule::SetRadiusFactor(float NewRadiusFactor)
{
  RadiusFactor = NewRadiusFactor;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetPerspectiveFactor
int CMolecule::SetPerspectiveFactor(float NewPerspectiveFactor)
{
  int result = 1;
  PerspectiveFactor = NewPerspectiveFactor;
  if(PerspectiveFactor > MAX_PERSPECTIVEFACTOR)
  {
    PerspectiveFactor = MAX_PERSPECTIVEFACTOR;
    result = 0;
  }
  if(PerspectiveFactor < 0.0)
  {
    PerspectiveFactor = 0.0;
    result = 0;
  }
  return(result);
}

/////////////////////////////////////////////////////////////////////////////
// SetZoomFactor
int CMolecule::SetZoomFactor(float NewZoomFactor)
{
  ZoomFactor = NewZoomFactor;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetLabelType
int CMolecule::SetLabelType(int NewLabelType)
{
  LabelType = NewLabelType;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetView
int CMolecule::SetView(int NewView)
{
  View = NewView;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetBondFudge
int CMolecule::SetBondFudge(float NewBondFudge, int updateBonds)
{
  BondFudge = NewBondFudge;
  if(updateBonds)
  {
    int result = TRUE;
    int tmpresult = TRUE;
    float Distance2D;
    float MaxBondDistance;
    int tmpNumberOfBonds = NumberOfBonds;
    int i = 0;
    int j = 0;
    // delete all bonds
    for(i = 0; i < tmpNumberOfBonds; i++)
    {
      tmpresult = DeleteBond(BondPartners[0].x, BondPartners[0].y);
      if(tmpresult == FALSE) result = FALSE;
    }
    // calculate bonds
    for(i = 0; i < (NumberOfAtoms - 1); i++)
    {
      for(j = i + 1; j < NumberOfAtoms; j++)
      {
        Distance2D = (float)sqrt(pow((Element[i].x - Element[j].x),2) +
                                 pow((Element[i].y - Element[j].y),2) +
                                 pow((Element[i].z - Element[j].z),2));        
        MaxBondDistance = (Element[i].Radius +
                           Element[j].Radius) *
                           BondFudge;
        if(Distance2D <= MaxBondDistance)
        {
          // bond found
          tmpresult = AddBond(i, j);
          if(tmpresult == FALSE) result = FALSE;
        }
      }
    }
    return result;
  }
  else
    return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetBondColor
int CMolecule::SetBondColor(QColor NewBondColor)
{
  BondColor = NewBondColor;
  return(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// SetBackgroundColor
int CMolecule::SetBackgroundColor(QColor newBGColor)
{
  bgColor = newBGColor;
  return(TRUE);
}



